/*---------------------------------------------------------------------------------
 bbEdgeFlip ( 2004 Slade Taylor [bladestaylor@yahoo.com])
 ----------------------------------------------------------------------------------
 bbEdgeFlip is a plugin for Blackbox for Windows.  For more information,
 please visit [http://bb4win.org] or [http://sourceforge.net/projects/bb4win].
 ----------------------------------------------------------------------------------
 bbEdgeFlip is free software, released under the GNU General Public License,
 version 2, as published by the Free Software Foundation.  It is distributed
 WITHOUT ANY WARRANTY--without even the implied warranty of MERCHANTABILITY
 or FITNESS FOR A PARTICULAR PURPOSE.  Please see the GNU General Public
 License for more details:  [http://www.fsf.org/licenses/gpl.html].
 --------------------------------------------------------------------------------*/

#ifndef _WIN32_WINNT
    #define _WIN32_WINNT 0x0500
#endif

#define VC_EXTRALEAN

#include <windows.h>

//----------------------------

#define FLIP_WM_MOVING      12000
#define FLIP_WM_MOUSEMOVE   12002

//---------------------------------------------------------------------------------

extern "C"
{
    __declspec(dllexport) void SetHook();
    __declspec(dllexport) void UnsetHook();
};

bool WINAPI DllMain(HINSTANCE, DWORD, LPVOID);
static LRESULT CALLBACK HookProc(int, WPARAM, LPARAM);
static LRESULT CALLBACK MouseProc(int, WPARAM, LPARAM);

//---------------------------------------------------------------------------------

static HHOOK        hHook = NULL;
static HHOOK        hMouseHook = NULL;
static HWND         hDesktopWnd = NULL;
static DWORD        BBThread = 0;
static HINSTANCE    hInstance = NULL;
static HWND         hFlipWnd = NULL;

//---------------------------------------------------------------------------------
